/*
Copyright (C) 2006-2009 Noah Graham, all rights reserved.
See license.txt for permissible uses.

Refer to 

N. Graham, ``An Electroweak Oscillon,'' hep-th/0610267, Phys. Rev. Lett. 98 (2007) 101801

and/or

N. Graham, arXiv:0706.4125 [hep-th], ``Numerical Simulation of an Electroweak Oscillon,'' Phys. Rev.  D 76 (2007) 085017

in any publications or other products making use of this code.

*/

#ifndef __STYLE_H
#define __STYLE_H

// c includes
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <limits.h>
#include <float.h>
#include <math.h>


// c++ includes
#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;

extern char *progname;

#ifdef DEBUG
#define DEBUG_CODE(a) a
#else
#define DEBUG_CODE(a)
#endif

template <class T>
inline const T abs(const T a)
{ return a>=0 ? a : -a; }

#ifndef M_PI
#define M_PI 3.141592654
#define M_PI_2 M_PI*0.5
#endif

#ifdef DEBUG

#ifdef _MSC_VER
#define weak_assert(x) do { if (!(x)) _asm { int 3 } } while(0)
#else
#define weak_assert(x) do { if (!(x)) { cout << "assert failed! " __FILE__ << " " << __LINE__ << endl; exit(-1); } } while(0)
#endif

#endif

#ifndef DEBUG
#define weak_assert(x)
#endif

template <class T>
inline T sqr(T a) { return a*a; }

#endif

